{$M 16384,0,256000}
Program CJ_PARTY_INVITATION_INTRO;
Uses Dos, Crt, V_Sharp, P_Sharp, Mpalette,{ Music,} TPac, D_Sharp;

Const
 Amount = 24;    { number of circles }
 add1 =  1;
 add2 = -1;
 add3 = -1;

Var
  ctab   : array[0..199] of byte;
  stab1,
  stab2,
  stab3  : array[0..255] of byte;
 i1,
 i2, i3  : word;

 I, J           : Integer;
 P1, P2         : PaletteArray;

 Circles        : Array[1..360, 1..Amount] of word;
 Xsinus,
 Ysinus         : Array[1..720] of integer;

 SinPtr,
 Xx, Yy,
 x, y, a        : integer;
 r              : real;

 Blur_Const     : integer;
 Contrast       : integer;

 DelF           : file;

Procedure Init;
Begin
 For i:=0 To 255 Do
  Begin
    stab1[i]:=Round(sin(i*2*pi/255)*50)+109;
    stab2[i]:=Round(cos(i*4*pi/255)*25);
    stab3[i]:=Round(sin(i*4*pi/255)*25);
  End;
  FillChar(ctab, SizeOf(ctab), 0);
  i1:=0; i2:=25; i3:=100;
End;

Procedure Waves;
Var
  x, y : word;
Begin
  Repeat
   For i:=0 To 199 Do
    begin
      ctab[i]:=stab1[(i+i1) mod 255]+stab2[(i+i2) mod 255]+stab3[(i+i3) mod 255];
      PutPixel(SBuffer,ctab[i]+50,i,120);
      PutPixel(SBuffer,ctab[i]+51,i,120);
      PutPixel(SBuffer,ctab[i]+52,i,120);
      PutPixel(SBuffer,ctab[i]+53,i,120);
      PutPixel(SBuffer,ctab[i]+54,i,120);
      PutPixel(SBuffer,ctab[i]+55,i,120);
      ctab[i]:=stab1[(i+i1) mod 255]+stab3[(i+i3) mod 255];
      PutPixel(SBuffer,ctab[i] div 2+100,i,120);
      PutPixel(SBuffer,ctab[i] div 2+101,i,120);
      PutPixel(SBuffer,ctab[i] div 2+102,i,120);
      PutPixel(SBuffer,ctab[i] div 2+103,i,120);
      PutPixel(SBuffer,ctab[i] div 2+104,i,120);
      PutPixel(SBuffer,ctab[i] div 2+105,i,120);
      ctab[i]:=stab1[(i+i1) mod 255]+stab2[(i+i2) mod 255];
      PutPixel(SBuffer,ctab[i]+50,i,120);
      PutPixel(SBuffer,ctab[i]+51,i,120);
      PutPixel(SBuffer,ctab[i]+52,i,120);
      PutPixel(SBuffer,ctab[i]+53,i,120);
      PutPixel(SBuffer,ctab[i]+54,i,120);
      PutPixel(SBuffer,ctab[i]+55,i,120);
    end;

    i1:=(i1+add1) mod 255; i2:=(i2+add2) mod 255; i3:=(i3+add3) mod 255;

   WriteXY(DBuffer, 55+Round(Random(4)),40+Round(Random(4)),'WELCOME TO');
   WriteXY(DBuffer, 68+Round(Random(4)),60+Round(Random(4)),'CJ PARTY');

    Bicubic_Filtering(SBuffer^);
    Transparent_Motion_Blur(1);
  Until (KeyPressed) and (ReadKey=#27);

End;

{ Cuted from CUZ_CRT.PAS :) }
function StrToInt(S: string): longint;
var
 Code : integer;
 i : longint;
begin
 Val(S, i, Code);
 StrToInt := i;
end;

Begin { Main(); }

 if ParamCount < 2 then
  begin
   Blur_Const:=6;
   Contrast  :=30;
  end
 else
  begin
   Blur_Const:=StrToInt(ParamStr(1));
   Contrast  :=StrToInt(ParamStr(2));
  end;

 For i:=1 to 10 do ExtractFile[i] := '';

{
 ExtractFile[1] := 'sbpro.mse';    ExtractFiles('wrc_blur.pak');
 ExtractFile[1] := '3tran.gdm';      ExtractFiles('wrc_blur.pak');
 InitializeMusic;
 Assign(DelF, 'sbpro.mse'); Erase(DelF);
 Assign(DelF, '3tran.gdm'); Erase(DelF);
}

 Init13h;
 initVariables;
 LoadTED('FONT011');

 FillChar(SBuffer^, SizeOf(DBuffer^), 0);
 FillChar(DBuffer^, SizeOf(DBuffer^), 0);

 ExtractFile[1] := 'wrc_blur.pcx'; ExtractFiles('wrc_blur.pak');
 ReadPCXfile(BackGround, 'wrc_blur.pcx', 0, 0);
 Assign(DelF, 'wrc_blur.pcx'); Erase(DelF);

{
 ReadPCXfile(BackGround, 'texture.pcx', 0, 0);
}

 for i:=0 to 319 do
  for j:=0 to 199 do
   PutPixel(BackGround, i, j, GetPixel(BackGround, i, j) + Contrast);

  For A:=1 To Amount Do
   Begin
    R:=0;
    For X:=1 To 360 Do
     Begin
      R:=R+(0.0175)*4;
      Circles[X,A]:=Round(sin(R)*(5+(A shl 2)))+(5+(A shl 2));
     End;
   End;

  R:=0;
  For X:=1 To 720 Do
   Begin
    R:=R+0.0175;
    Xsinus[X]:=Round(sin(R)*140)+140;
    Ysinus[X]:=Round(cos(R)*90)+90;
   End;
  SinPtr:=0;

 For i:=0 to 255 do
  Begin
   P1[i].R:=63;
   P1[i].G:=63;
   P1[i].B:=63;
  End;

 FadeFromPaletteToPalette(PaletteUsr, P1);
 Screen_13h^:=BackGround^;
 FadeFromPaletteToPalette(P1, PaletteUsr);

{
 BeginMusic;
}

{ FadePalette(0,0,0,23,53,53,0,255); }

 Repeat

   if SinPtr > 358 then SinPtr:=0;
   inc(SinPtr, 2);

   For A:=1 To Amount Do
    For X:=1 To 90 Do
     Begin
      Xx:=(Circles[X,A]+Xsinus[(A shl 3)+SinPtr])-A*4;
      Yy:=(Circles[X+23,A]+Ysinus[SinPtr+90+(A shl 2)])-(A*4);

      If ((Xx>0) And (Xx<319)) Then
       If ((Yy>0) And (Yy<199)) Then
        PutPixel(DBuffer, Xx, Yy, A+80);
     End;

   WriteXY(DBuffer, 55+Round(Random(4)),100+Round(Random(4)),'WELCOME TO');
   WriteXY(DBuffer, 68+Round(Random(4)),130+Round(Random(4)),'CJ PARTY');

   WaitRetrace;
   Transparent_Motion_Blur(Blur_Const);

 Until Keypressed;
 While KeyPressed do ReadKey;

 SetPaletteM(P1);
 Init;
 FadeFromPaletteToPalette(P1, PaletteUsr);
 Waves;

{
 CloseMusic;
}

 FadeFromPaletteToPalette(PaletteUsr, P1);
 FadeFromPaletteToPalette(P1, PaletteTmp);

 DoneTED;
 killVariables;
 kill13h;

 WriteLn(' -- Code by VanDamM // [WRC''1999] -- ');

End.
